# -*- coding: utf-8 -*-
"""
Created on Thu Feb 14 13:48:27 2019

@author: jcnossen1
"""

# -*- coding: utf-8 -*-
import matplotlib.pyplot as plt
import numpy as np
import h5py
import os
from shutil import copyfile
from smlmlib.base import SMLM

import utils.localizations as loc
import argparse

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Apply drift file to HDF5")
    parser.add_argument("-i", "--input", help="Input localizations file (.hdf5)")
    parser.add_argument("-i", "--input", help="Input localizations file (.hdf5)")
    parser.add_argument("--framemul", default=1, help="Frame multiplier. len(drift) = framemul*len(hdf5)")
    args = parser.parse_args()
    
    if args.input:
            
        os.makedirs(output, exist_ok=True)
        
        dataname = os.path.split(args.input)[1]
        
        with SMLM() as smlm:
            result = loc.load(args.input, cfg, smlm, rebuild=args.rerun)
            result.drift_estimate_cc(smlm, args.driftbins, smooth_sigma=4)
            result.apply_drift_correction(result.drift, args.driftbins)
                
            fig = result.plot_drift(f'Estimated drift {dataname}')
            fig.savefig(output + "drift.png")
            
            result.save_csv(output + "locs.csv")
            result.save_picasso_hdf5(output + "locs.hdf5")
            
    else:
        parser.print_help()
        

def filter_hdf5(inputfile, outputfile, searchdist, mincount):
    
    with h5py.File(inputfile, 'r') as f:
        with h5py.File(outputfile, 'w') as fo:
#            fo['locs'] = f['locs']
 
            d = f['locs'][:]
            
            xy = np.zeros((len(d),2))
            xy[:,0] = d['x']
            xy[:,1] = d['y']
            nbcounts = count_neighbors(xy, searchdist)
            
            plt.figure()
            plt.hist(nbcounts)
            
            filtered = d[nbcounts>=mincount]
            print(f"removed {len(d)-len(filtered)} out of {len(d)} localizations")
            fo.create_dataset('locs',filtered.shape,filtered.dtype,filtered)
            
            copyfile(os.path.splitext(inputfile)[0]+".yaml",
                     os.path.splitext(outputfile)[0]+".yaml")
            
            return d
        
        
if __name__ == "__main__":
    
    fn = 'O:/sim1_1/results/sim1_1/g2d.hdf5'
    d=filter_hdf5(fn, 'O:/sim1_1/results/sim1_1/g2d_filtered.hdf5', 0.2, 2)
    
    
    