#pragma once

#include "DLLMacros.h"
#include <string>

class PSF;



struct FFTPupil_Params
{
	int fftsize;
	int roisize;
	int numzernike;
	float sigma;
	float wavelength, NA, n1, n2, focalDepth;
	float pixelsize; // in sample space [um]
	int maxiterations;
	float zmin, zmax;
	float lambdaStep, border;

	DLL_EXPORT FFTPupil_Params(int fftsize = 128, int roisize = 20, int numzernike = 30, float sigma = 0.7f, float wavelen = 0.64f,
		float NA = 1.2f, float n1 = 1.33f, float n2 = 1.33f, float focalDepth = 0.5f, float pixelsize = 0.1f, int maxIterations = 40, float zmin = -5.0f, float zmax = 5.0f, float lambdaStep = 1.0f, float border = 5.0f);
	DLL_EXPORT std::string ToString() const;

	float MaxFreq() const { return NA / wavelength; }
	float ZernikeUnitRadius() const { return MaxFreq() * fftsize*pixelsize; }
};

// If !zernikeAsSpotConstants, then zernike_coeff should be given
CDLL_EXPORT PSF* FFTPupilPSF_Create(const FFTPupil_Params& params, bool zernikeAsSpotConstants = true, const float* zernike_coeff = 0);

