
#include "PSF.h"
#include "FFTPupilPSF.h"
#include "Zernike.h"

class FFTPupilPSF : public CUDA_PSF 
{
public:
	FFTPupilPSF(FFTPupil_Params p, bool zernikeSpotConst);
	~FFTPupilPSF();

	// d_image[numspots, SampleCount()], d_theta[numspots, ThetaSize()]
	virtual void ExpectedValue(float* expectedvalue, const float* d_theta, const float* d_const, const int* d_spotpos, int numspots, cudaStream_t stream);
	// d_deriv[numspots, ThetaSize(), SampleCount()], d_expectedvalue[numspots, SampleCount()], d_theta[numspots, ThetaSize()]
	virtual void Derivatives(float* deriv, float *expectedvalue, const float* theta, const float* d_const, const int* d_spotpos, int numspots, cudaStream_t stream);

protected:
	FFTPupil_Params params;
	int numZernikeConst;
	std::vector<float> zernikeCoeff;

	ZernikePolynomialBuffer zernikeBuffer;
};

