#pragma once

#include "DLLMacros.h"
#include "Vector.h"

// SILM Modes
#define SILM_SIMPLE 0
#define SILM_USE_SWITCH_FRAMES 1		// Use a switch-on and a switch-off intensity parameter
#define SILM_SWITCH_FRAME_SUM 2	// Use a single switch-frame intensity parameter and sum all intensities
#define SILM_CHOP_ENDS 3				// Simple model but remove switching frames

struct SILM_ASW_Params {
	int roisize;
	int numepp;
	float psfSigma;
	int maxLevMarIterations;
	float levMarLambdaStep;
	int mode; 
};

// Q(x,y) = power*(1+depth*sin(kx*x + ky*y - phase))
struct SILM_Modulation {
	float kx, ky;
	float depth;
	float phase;
	float power;
};

struct SILM_BlinkHMM_Params
{
#ifdef __cplusplus
	static DLL_EXPORT SILM_BlinkHMM_Params Compute(float T_on, float T_off, float fps);
#endif

	float prior; // p(on)
	float p_on2off, p_off2on;
	float p_on_threshold;
	float intensityThreshold;
	float excitationThreshold;
};

typedef Vector4f SILM_Theta;
